﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.Net.Sockets;
using System.Threading;


namespace Ethernet_data
{
    public partial class frmmain : Form
    {
        const int _readerip = 0, _SubnetMask = 1, _Gateway = 2, _MAC = 3, _devicename = 4, _power = 5, _state = 6;

        private const string scanreader = "Searching Reader";
        private const string scanreader_ok = "Successful connection   ";
        private const string scanreader_fail = "Please check \n 1、The DL9230 Reader connected? \n 2、If already connected, connect it to the router  \n 3、In the system firewall to allow it";
        private const string ip_fail ="Different network segments, or address conflicts, setting"; //"网段不同或地址冲突，正在设置";
        private const string set_ok = "Set DL9230 Reader IP success";
        private const string set_fail ="Failed to set the IP"; // "设置IP失败";
        private const string start_read = "Start reading Tag";
        private const string stop_read = "Stop Reading Tag";
        private const string nofindreader = "Connection Failed";
        private const string setip_fail = "Set the IP address failed  ";
        private const string setWordMode_fail ="Failed to set the working mode    "; // "设置工作模式失败     ";
        private const string getlocalfail ="Failed to get the PC client IP address";  // "没能获取电脑端IP地址";

        #region  TCPIP  用到的变量

        TcpListener m_sockListener = null;
        public TcpClient[] m_tcpClient = new TcpClient[0];
        TcpClient currtcpclient = null;

        private Socket UDP;
        private UdpClient UDP_send;
        private IPEndPoint iep;
        private bool Closeing = false;
        private bool  resing=false ;
        private byte[] receive_data = new byte[1024];
        private string[] ComputerIP = new string[3];
        string[,] network_info = new string[10,4];
        //private RFIDLib.TcpReader_5 tcp_reader = new RFIDLib.TcpReader_5();
        #endregion

        /*************************************************************************/
        public struct TAGDATA
        {
            public byte addr;     //读卡器地址
            public byte volt;     //标签电压 0：正常，1：欠压
            public uint tagID;    //卡号
            public DateTime time; //时间
        }
        List<TAGDATA> listTag;
        /*************************************************************************/

        public frmmain()
        {
            InitializeComponent();
            CheckForIllegalCrossThreadCalls = false;
        }
        #region  TCPIP 数据通讯(UDP)

        private bool read_message(byte[] data)
        {
            try
            {
                UDP = new Socket(AddressFamily.InterNetwork, SocketType.Dgram, ProtocolType.Udp);
                UDP.SetSocketOption(SocketOptionLevel.Socket, SocketOptionName.ReuseAddress, true);
                IPEndPoint iep1 = new IPEndPoint(IPAddress.Any, 65534);
                EndPoint Remote = (EndPoint)(iep1);
                UDP.Bind(Remote);

                iep = new IPEndPoint(IPAddress.Parse("255.255.255.255"), 65533);
                UDP_send = new UdpClient();
                UDP_send.Send(data, data.Length, iep);//发送数据
                UDP_send.Close();
                
                autoconnect.Enabled = false;
                bool result = listen();
                return result;
            }
            catch (Exception err)
            {

                MessageBox.Show(err.Message, "", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return false;
            }
        }

        private bool listen()//监听
        {
            try
            {
                bool result=false;
                int delaytime = 0;
                while (true)
                {
                    Thread.Sleep(100);
                    if (delaytime++ > 20)
                    {
                        return result;
                    }

                    while (Closeing)
                    {
                        Application.DoEvents();
                    }
                    if (UDP != null)
                    {
                        if (UDP.Available > 0)
                        {
                            delaytime = 0;
                            resing = true;
                            UDP.Receive(receive_data);//返回接受的数据 Encoding.UTF8.GetString
                            resing = false;
                          //  if (receive_data.Length != 208) continue;
                            if (receive_data[207] != 13) continue;

                            if (receive_data[1] == 0x10 && receive_data[2] == 0x04)      //获取设备应答
                            {
                                string devicename, IP, SubnetMask, Gateway, MAC;
                                MAC = receive_data[72] + "-" + receive_data[73] + "-" + receive_data[74] + "-" + receive_data[75] + "-" + receive_data[76] + "-" + receive_data[77];
                                IP = receive_data[78] + "." + receive_data[79] + "." + receive_data[80] + "." + receive_data[81];
                                SubnetMask = receive_data[82] + "." + receive_data[83] + "." + receive_data[84] + "." + receive_data[85];
                                Gateway = receive_data[86] + "." + receive_data[87] + "." + receive_data[88] + "." + receive_data[89];
                                byte[] name = new byte[21];
                                Array.Copy(receive_data, 90, name, 0, 21);
                                devicename = Encoding.Default.GetString(name);
                                devicename = devicename.Substring(0, devicename.IndexOf('\0'));

                                string[] str =new string[ListView1.Columns.Count];
                                str[0]=IP;
                                str[1]=SubnetMask;
                                str[2]= Gateway;
                                str[3]=MAC;
                                str[4]=devicename;
                                for (int i = 5; i < ListView1.Columns.Count; i++)
                                {
                                    str[i] = "";
                                }
                                ListViewItem item = new ListViewItem(str);
                                item.Checked = true;
                                item.ImageIndex = 0;
                                ListView1.Items.Add(item);

                                result = true;
                                delaytime = 0;
                            }
                            else if (receive_data[1] == 0x10 && receive_data[2] == 0x06)      //设置设备IP地址应答
                            {
                                if (receive_data[77] > 0)
                                {
                                    MessageBox.Show(setip_fail, "", MessageBoxButtons.OK, MessageBoxIcon.Error);
                                    return false;
                                }
                                return true;
                            }
                            else if (receive_data[1] == 0x10 && receive_data[2] == 0x1F)      //设置设备工作模式应答
                            {
                                if (receive_data[119] == 0)
                                {
                                    MessageBox.Show(setWordMode_fail, "", MessageBoxButtons.OK, MessageBoxIcon.Error);
                                    return false;
                                }
                                return true;
                            }

                        }
                    }
                    Application.DoEvents();
                }
            }
            finally
            {
                if (UDP != null) UDP.Close();
                autoconnect.Enabled = true;
            }
        }
        #endregion

        //***************************************************************************************************************
        #region 其它事件

        private void Form3_Load(object sender, EventArgs e)
        {
            this.Text = Application.ProductName + "  V" + Application.ProductVersion;
            dataGridView1.RowCount = 0;
            dataGridView1.Columns[2].DefaultCellStyle.ForeColor = Color.Blue;

            comboBox_port.Text = "10000";

            int network_count = 0;
            Class3.getNetwork(ref network_info, ref network_count); //取本机IP 子网掩码 网关
            for (int i = 0; i < network_count; i++)
            {
                comboBox_ip.Items.Add(network_info[i, 0]);
            }
            if (comboBox_ip.Items.Count == 1) comboBox_ip.SelectedIndex=0;
        }
        private void frmmain_Shown(object sender, EventArgs e)
        {
            //getreaderip_Click(null, null);
        }
        private void frmmain_FormClosing(object sender, FormClosingEventArgs e)
        {
            while (resing)
            {
                Application.DoEvents();
            }
            Closeing = true;
            //tcp_reader.Stop();
            foreach (TcpClient item in m_tcpClient)
            {
                if (item != null)
                {
                    if(item .Connected) item.Close();
                }
            }
        }
        private void addinfo(string infoname, bool iserror)
        {
            string[] info = new string[2];
            info[0] = (dataGridView2.RowCount + 1).ToString();
            info[1] = DateTime.Now.ToLongTimeString() + "  " + infoname;
            dataGridView2.Rows.Add(info);
            dataGridView2[0,dataGridView2.RowCount - 1].Selected = true;
            if (iserror) dataGridView2.Rows[dataGridView2.RowCount - 1].DefaultCellStyle.ForeColor = Color.Red;
            dataGridView2.FirstDisplayedScrollingRowIndex = dataGridView2.RowCount - 1;
        }

        private void button2_Click(object sender, EventArgs e)
        {
            dataGridView2.RowCount = 0;
        }
        private void comboBox1_KeyPress(object sender, KeyPressEventArgs e)
        {
            e.Handled = "0123456789.\b".IndexOf(e.KeyChar) < 0;
        }
        private void comboBox_port_KeyPress(object sender, KeyPressEventArgs e)
        {
            e.Handled = "0123456789\b".IndexOf(e.KeyChar) < 0;
        }

        private void Clearbtn_Click(object sender, EventArgs e)
        {
            dataGridView1.RowCount = 0;
            label7.Text = "0";
        }
        private void tag_show(string ip,string addr,string tagID,string time)
        {
            bool findok = false;
            for (int row = 1; row < dataGridView1.RowCount; row++)
            {
                if (tagID == dataGridView1[3, row].Value.ToString() && ip == dataGridView1[1, row].Value.ToString())
                {
                    dataGridView1[4, row].Value = time;
                    dataGridView1[5, row].Value = (int.Parse(dataGridView1[5, row].Value.ToString()) + 1).ToString();
                    //dataGridView1[4, row].Selected=true;
                    findok = true;
                    break;
                }

            }
            if (!findok)
            {
                string[] str1 = new string[6];
                str1[0] = (dataGridView1.RowCount + 1).ToString();
                str1[1] = ip;
                str1[2] = addr;
                str1[3] = tagID;
                str1[4] = time;
                str1[5] = "1";
                dataGridView1.Rows.Add(str1);
                dataGridView1.FirstDisplayedScrollingRowIndex = dataGridView1.RowCount - 1;
            }
            label7.Text = dataGridView1.RowCount.ToString();
        }

        #endregion

        #region  reader connect 连接相关函数或事件

        private void autoconnect_Click(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;
            try
            {

                if (searchReader())
                {
                    comboBox_ip.Text = ComputerIP[0];
                    comboBox_port.Text  = "10000";
                    getTagbtn_Click(null, null);
                }
            }
            finally
            {
                this.Cursor = Cursors.Default;
            }
        }
        private void getTagbtn_Click(object sender, EventArgs e)
        {
            if (getTagbtn.Enabled == false) return;
            if (string.IsNullOrEmpty(getTagbtn.Tag.ToString()))
            {
                if (comboBox_ip.Text.Trim() == "")
                {
                    comboBox_ip.Focus();
                    return;
                }
                getTagbtn.Enabled = autoconnect.Enabled = panel2.Enabled = false;
                dataGridView1.Rows.Clear();
                if (Tcpip_connect(comboBox_ip.Text, comboBox_port.Text))
                {
                    timer1.Enabled = true;
                    addinfo(start_read, false);
                    getTagbtn.Text = "Stop";
                    getTagbtn.Tag = "1";
                }
                else
                {
                    panel2.Enabled = autoconnect.Enabled = true;

                }
                getTagbtn.Enabled = true;
            }
            else
            {
                timer1.Enabled = false;
                addinfo(stop_read, false);
                panel2.Enabled = autoconnect.Enabled = true;
                getTagbtn.Text ="Start";
                getTagbtn.Tag =  "";
            }
        }

        private bool Tcpip_connect(string IP,string port)
        {
            changeConnectState(-1, "");
            foreach (TcpClient item in m_tcpClient)
            {
                if (item != null)
                {
                    try
                    {
                        if (item.Connected) item.Close();
                    }
                    catch { }
                }
            }
            m_tcpClient = new TcpClient[0];

            if (Creat_tcpconnect(IP,port,false))
            {
                btnItemGetDB_Click(null, null);

                dataGridView1.Rows.Clear();
                label9.Text = ComputerIP[0];
                label11.Text = ComputerIP[1];
                label13.Text = ComputerIP[2];
                //label11.Visible = label12.Visible = label13.Visible = label14.Visible = true;
                comboBox_ip.Text = ComputerIP[0];
                tabControl1.SelectedIndex = 0;
                panel1.Enabled = true;
                //addinfo(scanreader_ok + "-TCP/IP", false);
                return true;
            }
            return false;
        }
        /// <summary>
        /// Search reader and setting
        /// </summary>
        /// <param name="IP"> computer ip </param>
        /// <returns></returns>
        private bool searchReader()
        {
            panel1.Enabled = false;
            ListView1.Items.Clear();

            int docount = 0;
            bool result = false;
            byte[] data = reader.GetReader_list();
            addinfo(scanreader, false);
            while (docount++ < 2)
            {
                result = read_message(data);
                if (result) break;
            }
            if (result == false)
            {
                MessageBox.Show(scanreader_fail, nofindreader, MessageBoxButtons.OK, MessageBoxIcon.Error);
                //addinfo(scanreader_fail, true);
                return false;
            }

            int network_count = 0;
            Class3.getNetwork(ref network_info, ref network_count); //取本机IP 子网掩码 网关
            if (network_count == 0)  //没有网卡
            {
                addinfo(getlocalfail, true);
                return false;
            }
            else if (network_count == 1)  //只有一张网卡
            {
                int index = 0;
                ComputerIP[0] = network_info[index, 0];
                ComputerIP[1] = network_info[index, 1];
                ComputerIP[2] = network_info[index, 2];
            }
            else //有多张网卡
            {

                Form3 frm = new Form3();
                DataGridView grid1 = frm.grid1;
                for (int i = 0; i < network_count; i++)
                {
                    grid1.Rows.Add(); ;
                    grid1[0, grid1.Rows.Count - 1].Value = network_info[i, 3];
                    grid1[1, grid1.Rows.Count - 1].Value = network_info[i, 0];
                    grid1[2, grid1.Rows.Count - 1].Value = network_info[i, 1];
                    grid1[3, grid1.Rows.Count - 1].Value = network_info[i, 2];
                }
                if (frm.ShowDialog(this) != DialogResult.OK)
                {
                    return false;
                }
                ComputerIP[0] = grid1[1, grid1.SelectedRows[0].Index].Value.ToString();
                ComputerIP[1] = grid1[2, grid1.SelectedRows[0].Index].Value.ToString();
                ComputerIP[2] = grid1[3, grid1.SelectedRows[0].Index].Value.ToString();
            }
           
            bool IPsame = false;
            foreach (ListViewItem item in ListView1.Items)
            {
                string[] tmp1 = item.Text.Split('.');
                string[] localtion = ComputerIP[0].Split('.');
                IPsame = false;
                for (int i = 0; i < item.Index; i++)
                {
                    if (item.SubItems[_readerip].Text == ListView1.Items[i].SubItems[_readerip].Text)
                    {
                        IPsame = true;
                        break;
                    }
                }
                if (IPsame||item.SubItems[_SubnetMask].Text != ComputerIP[1] || item.SubItems[_Gateway].Text != ComputerIP[2] || tmp1[0] != localtion[0] || tmp1[1] != localtion[1] || tmp1[2] != localtion[2] || item.SubItems[_readerip].Text == ComputerIP[0]) //网段不同或掩码不同或网关不同
                {
                    addinfo(ip_fail, true);

                    string newip = Class3.ScanTarget(localtion[0] + "." + localtion[1] + "." + localtion[2]); //获取局域网一个空闲IP
                    if (string.IsNullOrEmpty(newip)) return false;

                    data = reader.SETReader(newip, ComputerIP[1], ComputerIP[2],item .SubItems[_MAC].Text); //设置reader IP
                    if (read_message(data))
                    {
                        ListView1.Items[item.Index].SubItems[_readerip].Text = newip;
                        ListView1.Items[item.Index].SubItems[_SubnetMask].Text = ComputerIP[1];
                        ListView1.Items[item.Index].SubItems[_Gateway].Text = ComputerIP[2];
                        addinfo(set_ok, false);
                    }
                    else
                    {
                        addinfo(set_fail, true);
                        return false;
                    }
                }
                data = reader.Set_WorkMode(ComputerIP[0],item.SubItems[_MAC].Text); //设置工作模式
                if (!read_message(data))
                {
                    return false;
                }
            }
            return true;
        }
        private bool Creat_tcpconnect(string ip, string port, bool IsReconnect)
        {
            this.Cursor = Cursors.WaitCursor;
            
            try
            {
                IPAddress localAddr = IPAddress.Parse(ip);
                m_sockListener = new TcpListener(localAddr, int.Parse(port));
            }
            catch { }
            if (m_sockListener != null)
            {
                m_sockListener.Stop();
            }
            m_sockListener.ExclusiveAddressUse = false;
            m_sockListener.Start(ListView1.Items.Count);
            int delaytime = 30;
            TcpClient tcpclient_tmp = null;
            bool result = false;
            string iptmp = null;
            try
            {
                while (delaytime-- > 0)
                {
                    try
                    {
                        if (m_sockListener.Pending())
                        {
                            tcpclient_tmp = m_sockListener.AcceptTcpClient();//侦听到连接后创建客户端连接TcpClient 
                            if (tcpclient_tmp != null)
                            {
                                delaytime = 30;
                                iptmp = tcpclient_tmp.Client.RemoteEndPoint.ToString();
                                iptmp = iptmp.Substring(0, iptmp.IndexOf(':'));

                                if (IsReconnect) //重连接
                                {
                                    for (int i = 0; i < m_tcpClient.Length; i++)
                                    {
                                        string iptmp1 = m_tcpClient[i].Client.RemoteEndPoint.ToString();
                                        iptmp1 = iptmp1.Substring(0, iptmp1.IndexOf(':'));
                                        if (m_tcpClient[i].Connected == false && iptmp==iptmp1)
                                        {
                                            m_tcpClient[i] = tcpclient_tmp;
                                            ListViewItem item = ListView1.FindItemWithText(iptmp, false, 0);
                                            if (item != null)
                                            {
                                                if (item.Checked) //选择了
                                                {
                                                    changeConnectState(item.Index, "connected");
                                                    addinfo(scanreader_ok + iptmp, false);
                                                }
                                            }
                                            result = true;
                                            break;
                                        }
                                    }
                                }
                                else
                                {
                                    ListViewItem item = ListView1.FindItemWithText(iptmp, false, 0);
                                    if (item != null)
                                    {
                                        if (item.Checked) //选择了
                                        {
                                            Array.Resize(ref m_tcpClient, m_tcpClient.Length + 1);
                                            m_tcpClient[m_tcpClient.Length - 1] = tcpclient_tmp;
                                            result = true;
                                            changeConnectState(item.Index, "connected");
                                            addinfo(scanreader_ok + iptmp, false);
                                        }
                                    }
                                }
                            }
                        }
                    }
                    catch { }
                    Thread.Sleep(100);
                    Application.DoEvents();
                }
            }
            finally
            {
                if (m_sockListener != null)
                {
                    m_sockListener.Stop();
                    m_sockListener = null;
                    this.Cursor = Cursors.Default;
                }
            }
            if (result == false) addinfo(nofindreader, true);
            return result;
        }
        private void changeConnectState(int row,string value)
        {
            if (row >= 0)
            {
                ListView1.Items[row].SubItems[_state].Text = value;
                ListView1.Items[row].ForeColor = value == "" ? Color.DimGray : Color.Blue;
            }
            else
            {
                for (row = 0; row < ListView1.Items.Count; row++)
                {
                    ListView1.Items[row].SubItems[_state].Text = value;
                    ListView1.Items[row].ForeColor = value == "" ? Color.DimGray : Color.Blue;
                }
            }
        }
        private byte ReadAddr(TcpClient tcpclient)
        {
            byte addr = 0;

            byte[] sendBuf = new byte[] { 0xff, 0xff, 0x08, 0xee, 0xee };
            NetworkStream netStream;
            try
            {
                netStream = tcpclient.GetStream();//得到网络流 
                netStream.Write(sendBuf, 0, 5);
            }
            catch (Exception exp)
            {
                addinfo(exp.Message,true);
                return 0;
            }

            for (int i = 0; i < 20;i++)
            {
                int count = tcpclient.Available;

                if (count >= 5)
                {
                    byte[] recvBuf = new byte[count];
                    try
                    {
                        int recvLength = netStream.Read(recvBuf, 0, count);

                        if (recvLength >= 5 && recvBuf[0] == 0xFF && recvBuf[1] == 0xFF && recvBuf[3] == 0xEE && recvBuf[4] == 0xEE)
                        {
                            addr = recvBuf[2];
                            break;
                        }
                    }
                    catch (Exception exp)
                    {
                        addinfo(exp.Message,true);
                        return 0;
                    }
                }
                Thread.Sleep(50);
            }
            return addr;
        }
        /***************************************************TCPIP connect END***************************************************************************/
        #endregion

        #region read tag 获取标签相关事件或函数


        private void timer1_Tick(object sender, EventArgs e)
        {
            timer1.Stop();
            for (int i = 0; i < m_tcpClient.Length; i++)
            {
                currtcpclient = m_tcpClient[i];
                if (currtcpclient == null) continue;
                if (currtcpclient.Connected == false)
                {
                    string iptmp = currtcpclient.Client.RemoteEndPoint.ToString();
                    iptmp = iptmp.Substring(0, iptmp.IndexOf(':'));
                    ListViewItem item = ListView1.FindItemWithText(iptmp, false, 0);
                    if (item != null)
                    {
                        changeConnectState(item.Index, "");
                    }
                    if (MessageBox.Show(iptmp + " is already disconnecting,do you want to reconnect?    ", "", MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.Yes)
                    {
                        Creat_tcpconnect(comboBox_ip.Text, comboBox_port.Text, true);
                        continue;
                    }
                    else
                    {
                        m_tcpClient[i] = null;
                    }
                }
                readtag_tcpip(currtcpclient);
            }
            if (!string.IsNullOrEmpty(getTagbtn.Tag.ToString())) timer1.Start();
        }
        private void readtag_tcpip(TcpClient tcpclient)
        {
            byte Addr = ReadAddr(tcpclient);
            if (Addr == 0) return;

            byte[] sendBuf = new byte[] { Addr, 4, 1, 3 };
            byte[] recvBuf = new byte[4096];
            int recvBufLen = 0;
            try
            {
                NetworkStream netStream = tcpclient.GetStream();//得到网络流 
                netStream.Write(sendBuf, 0, 4);
                recvBufLen = 0;

                Thread.Sleep(50);
                for (int i = 0; i < 20; i++)
                {
                    int count = tcpclient.Available;
                    if (count > 0)
                    {
                        int dataLen = netStream.Read(recvBuf, recvBufLen, count);
                        recvBufLen += dataLen;

                        if (recvBufLen >= 6)
                        {
                            if (recvBuf[0] == 0xFF && recvBuf[1] == 0xFF && recvBuf[2] == Addr)
                            {
                                if (recvBuf[recvBufLen - 2] == 0xEE && recvBuf[recvBufLen - 1] == 0xEE)
                                {
                                    #region 2字节标签
                                    #endregion

                                    #region 5字节标签
                                    //5byte:ff ff 01 00 xx xx xx xx xx...ee ee

                                    listTag = new List<TAGDATA>();

                                    for (int j = 4; j < recvBufLen - 6; j += 5)
                                    {
                                        bool bVolt = ((recvBuf[j] & 0x80) == 0x80);

                                        uint tagID = (uint)(recvBuf[j + 1]);
                                        tagID <<= 8;
                                        tagID |= recvBuf[j + 2];
                                        tagID <<= 8;
                                        tagID |= recvBuf[j + 3];
                                        tagID <<= 8;
                                        tagID |= recvBuf[j + 4];
                                        tag_show(tcpclient.Client.RemoteEndPoint.ToString(), Addr.ToString(), tagID.ToString(), DateTime.Now.ToShortTimeString());

                                    }
                                    #endregion
                                    break;
                                }
                            }
                            else
                            {//数据格式错误
                                break;
                            }
                        }
                    }
                    Thread.Sleep(50);
                }
            }
            catch (Exception exp)
            {
                addinfo(exp.Message, true);
            }
        }
        #endregion

        #region    衰减值读取与设置

        //读取衰减值
        private void btnItemGetDB_Click(object sender, EventArgs e)
        {
            textBoxReaderDB.Text = "";
            foreach (ListViewItem item in ListView1.Items)
            {
                if (item.Checked == false) continue;
                string iptmp = "";
                foreach (TcpClient tcpItem in m_tcpClient)
                {
                    iptmp = tcpItem.Client.RemoteEndPoint.ToString();
                    iptmp = iptmp.Substring(0, iptmp.IndexOf(':'));
                    if (iptmp != item.SubItems[_readerip].Text) continue;
                    ListView1.Items[item.Index].SubItems[_power].Text = getDB_tcpip(tcpItem);
                }
            }
        }
         //设置衰减值
        private void btnItemSetDB_Click(object sender, EventArgs e)
        {
            if (textBoxReaderDB.Text.Trim() == "")
            {
                textBoxReaderDB.Focus();
                return;
            }

            foreach (ListViewItem item in ListView1.Items)
            {
                if (item.Checked == false) continue;
                string iptmp = "";
                foreach (TcpClient tcpItem in m_tcpClient)
                {
                    iptmp = tcpItem.Client.RemoteEndPoint.ToString();
                    iptmp = iptmp.Substring(0, iptmp.IndexOf(':'));
                    if (iptmp != item.SubItems[_readerip].Text) continue;
                    
                    if (setDB_tcpip(tcpItem))
                    {
                        ListView1.Items[item.Index].SubItems[_power].Text = textBoxReaderDB.Text;
                    }
                }
            }
        }
        private string  getDB_tcpip(TcpClient tcpclient)
        {
            byte Addr = ReadAddr(tcpclient);
            if (Addr == 0) return "";


            byte[] sendBuf = new byte[] { Addr, 0x04, 0x4c, 0x03 };

            NetworkStream netStream;
            try
            {
                netStream = tcpclient.GetStream();//得到网络流 
                netStream.Write(sendBuf, 0, sendBuf[1]);
            }
            catch (Exception exp)
            {
                MessageBox.Show(exp.Message);
                return "";
            }

            for (int i = 0; i < 20; i++)
            {
                int count = tcpclient.Available;

                if (count >= 6)
                {
                    byte[] recvBuf = new byte[count];
                    try
                    {
                        int recvLength = netStream.Read(recvBuf, 0, count);

                        if (recvLength >= 6 && recvBuf[0] == 0xFF && recvBuf[1] == 0xFF && recvBuf[4] == 0xEE && recvBuf[5] == 0xEE)
                        {
                            byte btDB = recvBuf[3];
                            textBoxReaderDB.Text = (31 - btDB).ToString();
                            addinfo("Get Power sucessfully!", false);
                            return textBoxReaderDB.Text;
                        }
                    }
                    catch { }
                }
                System.Threading.Thread.Sleep(50);
            }
            addinfo("Get Power failed", true);
            return "";
        }
        private bool setDB_tcpip(TcpClient tcpclient)
        {
            byte Addr = ReadAddr(tcpclient);
            if (Addr == 0) return false;

            byte btDB = 0;

            try
            {
                btDB = byte.Parse(textBoxReaderDB.Text.Trim());
            }
            catch (Exception exp)
            {
                MessageBox.Show(exp.Message);
                return false;
            }
            if (btDB > 31) btDB = 31;
            btDB = (byte)(31 - btDB);

            byte[] sendBuf = new byte[] { Addr, 0x05, 0xcc, btDB, 0x03 };

            NetworkStream netStream;
            try
            {
                netStream = tcpclient.GetStream();//得到网络流 
                netStream.Write(sendBuf, 0, sendBuf[1]);
            }
            catch (Exception exp)
            {
                MessageBox.Show(exp.Message);
                return false;
            }

            for (int i = 0; i < 20; i++)
            {
                int count = tcpclient.Available;

                if (count >= 6)
                {
                    byte[] recvBuf = new byte[count];
                    try
                    {
                        int recvLength = netStream.Read(recvBuf, 0, count);

                        if (recvLength >= 6 && recvBuf[0] == 0xFF && recvBuf[1] == 0xFF && recvBuf[3] == btDB && recvBuf[4] == 0xEE && recvBuf[5] == 0xEE)
                        {
                            addinfo("Set Power sucessfully!", false);
                            return true;
                        }
                    }
                    catch { }
                }
                System.Threading.Thread.Sleep(50);
            }
            addinfo("Set Power failed", true);
            return false;
        }
        #endregion

        private void gridreader_ItemChecked(object sender, ItemCheckedEventArgs e)
        {
            panel2.Enabled = getTagbtn.Enabled = false;
            foreach (ListViewItem item in ListView1.Items)
            {
                if (item.Checked)
                {
                    panel2.Enabled = getTagbtn.Enabled = true;
                    break;
                }
            }
        }

        private void gridreader_MouseDoubleClick(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Left)
            {
                if(ListView1 .SelectedItems.Count==0) return ;
                System.Diagnostics.Process.Start("http://" + ListView1.SelectedItems[0].SubItems[_readerip].Text);
            }
        }

        private void toolStripButton2_Click(object sender, EventArgs e)
        {
            ListView1.View = View.LargeIcon;
        }

        private void toolStripButton1_Click(object sender, EventArgs e)
        {
            ListView1.View = View.Details;
        }
    }
}